<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_HotelSimpleInfo StructType
 * @subpackage Structs
 */
class JP_HotelSimpleInfo extends AbstractStructBase
{
    /**
     * The HasSynonyms
     * Meta informations extracted from the WSDL
     * - use: required
     * @var bool
     */
    public $HasSynonyms;
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The Zone
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_Zone
     */
    public $Zone;
    /**
     * The Code
     * @var string
     */
    public $Code;
    /**
     * The JPCode
     * @var string
     */
    public $JPCode;
    /**
     * The SupplierCode
     * @var string
     */
    public $SupplierCode;
    /**
     * The GiataCode
     * @var string
     */
    public $GiataCode;
    /**
     * Constructor method for JP_HotelSimpleInfo
     * @uses JP_HotelSimpleInfo::setHasSynonyms()
     * @uses JP_HotelSimpleInfo::setName()
     * @uses JP_HotelSimpleInfo::setZone()
     * @uses JP_HotelSimpleInfo::setCode()
     * @uses JP_HotelSimpleInfo::setJPCode()
     * @uses JP_HotelSimpleInfo::setSupplierCode()
     * @uses JP_HotelSimpleInfo::setGiataCode()
     * @param bool $hasSynonyms
     * @param string $name
     * @param \StructType\JP_Zone $zone
     * @param string $code
     * @param string $jPCode
     * @param string $supplierCode
     * @param string $giataCode
     */
    public function __construct($hasSynonyms = null, $name = null, \StructType\JP_Zone $zone = null, $code = null, $jPCode = null, $supplierCode = null, $giataCode = null)
    {
        $this
            ->setHasSynonyms($hasSynonyms)
            ->setName($name)
            ->setZone($zone)
            ->setCode($code)
            ->setJPCode($jPCode)
            ->setSupplierCode($supplierCode)
            ->setGiataCode($giataCode);
    }
    /**
     * Get HasSynonyms value
     * @return bool
     */
    public function getHasSynonyms()
    {
        return $this->HasSynonyms;
    }
    /**
     * Set HasSynonyms value
     * @param bool $hasSynonyms
     * @return \StructType\JP_HotelSimpleInfo
     */
    public function setHasSynonyms($hasSynonyms = null)
    {
        // validation for constraint: boolean
        if (!is_null($hasSynonyms) && !is_bool($hasSynonyms)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($hasSynonyms)), __LINE__);
        }
        $this->HasSynonyms = $hasSynonyms;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\JP_HotelSimpleInfo
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Zone value
     * @return \StructType\JP_Zone|null
     */
    public function getZone()
    {
        return $this->Zone;
    }
    /**
     * Set Zone value
     * @param \StructType\JP_Zone $zone
     * @return \StructType\JP_HotelSimpleInfo
     */
    public function setZone(\StructType\JP_Zone $zone = null)
    {
        $this->Zone = $zone;
        return $this;
    }
    /**
     * Get Code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \StructType\JP_HotelSimpleInfo
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($code)), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
    /**
     * Get JPCode value
     * @return string|null
     */
    public function getJPCode()
    {
        return $this->JPCode;
    }
    /**
     * Set JPCode value
     * @param string $jPCode
     * @return \StructType\JP_HotelSimpleInfo
     */
    public function setJPCode($jPCode = null)
    {
        // validation for constraint: string
        if (!is_null($jPCode) && !is_string($jPCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($jPCode)), __LINE__);
        }
        $this->JPCode = $jPCode;
        return $this;
    }
    /**
     * Get SupplierCode value
     * @return string|null
     */
    public function getSupplierCode()
    {
        return $this->SupplierCode;
    }
    /**
     * Set SupplierCode value
     * @param string $supplierCode
     * @return \StructType\JP_HotelSimpleInfo
     */
    public function setSupplierCode($supplierCode = null)
    {
        // validation for constraint: string
        if (!is_null($supplierCode) && !is_string($supplierCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($supplierCode)), __LINE__);
        }
        $this->SupplierCode = $supplierCode;
        return $this;
    }
    /**
     * Get GiataCode value
     * @return string|null
     */
    public function getGiataCode()
    {
        return $this->GiataCode;
    }
    /**
     * Set GiataCode value
     * @param string $giataCode
     * @return \StructType\JP_HotelSimpleInfo
     */
    public function setGiataCode($giataCode = null)
    {
        // validation for constraint: string
        if (!is_null($giataCode) && !is_string($giataCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($giataCode)), __LINE__);
        }
        $this->GiataCode = $giataCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\JP_HotelSimpleInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
